/*
 * Rs[^bK 4-6: ȎQƍ\̂gP̌v
 * 2005N626         @
 * 2004N622        J ۔
 */

#include <stdio.h>
#include <stdlib.h>     /* exit(), malloc(), free() ̂ */
#include <string.h>     /* strcmp(), strlen(), strcpy() ̂ */

#define BSIZE    100     /* z̗vf */

/* AXg1̃m[h\\̂NodeƖD*/
/* node̓̕^ODȎQƂ̂߂Ƀ^O̒`Kv */
typedef struct node {
    struct node *next;  /* ̃m[hw|C^ */
    char        *word;  /* w|C^ */
    int         count;  /* Pꐔ𐔂ϐ */
} Node;

/* O̊֐̃vg^Cv錾 */
FILE    *openFile(char prompt[], char mode[]);
Node    *addNode(Node *prev, Node *cur, char *s);
Node    *allocNode(char *s);
void    printAllNode(Node *p);

int
main(void)
{
    FILE	*fp;
    char        buffer[BSIZE];
    Node        *header = NULL;

    fp = openFile("̓t@C    ", "r");

    /* ͂ȂȂ܂ŁCPǂݍ݃XgɒǉĂ */
    while ( 1 ) {
        /* A-Z,a-zȊOǂݔ΂ */
        fscanf(fp, "%*[^A-Za-z]");
        if ( feof(fp) ) break;

        /* A-Z,a-z\镶ǂݍ */
        fscanf(fp, "%[A-Za-z]", buffer);
        if ( feof(fp) ) break;

        header = addNode(NULL, header, buffer);
    }

    fclose(fp);
    
    /* Xg̓eʂɕ\ */
    printAllNode(header);
    
    return 0;
}

/*
 * t@C̓͂ƃt@C̃I[v
 * {̓I[vłȂꍇ̑ΏƒJɂׂD
 *
 *    prompt: ͂𑣂ۂɕ\镶
 *        mode:   fopen()Ɏg[h̕
 * ߂l         I[vt@C̃t@C|C^
 */
FILE *
openFile(char prompt[], char mode[])
{
    FILE *fp;
    char filename[BSIZE];
    
    printf(prompt);
    scanf("%s", filename);

    fp = fopen(filename, mode);
    if ( fp == NULL ) {
        printf("t@C%sI[vł܂DI܂D\n", filename);
	exit(1);
    }

    return fp;
}


/*
 * prev 1Õm[hw|C^
 *      (NULL̏ꍇ́Ccur擪AhXӖ)
 * cur  ݒڂĂm[hw|C^
 *      (NULL̏ꍇ́CXg܂̏ԂӖ)D
 * s    ǉ镶
 *
 * 1) scur̕ƈvȂ΁CcurcountlZD
 * 2) sR[hcur̕Ȃ΁C[ւ̃m[h̒ǉ邩C
 *    ֑(ċAĂяo)D
 * 3) sR[hcur̕OȂ΁Ccur̒OɃm[h}D
 *
 * ߂l: ̃Xg̐擪m[hw|C^
 */
Node *
addNode(Node *prev, Node *cur, char *s)
{
    Node        *new;
    int         c;

    if ( cur == NULL ) return allocNode(s);     /* Xg̏ꍇ */
        
    c = strcmp(cur->word, s);                   /* R[hŔr  */
    
    if ( c == 0 ) {                             /* cur̕Ɠ     */
        cur->count++;
    } else if ( c < 0 ) {                       /* cur̕       */
        if ( cur->next == NULL ) {              /*   cur[             */ 
            if ( (new = allocNode(s)) != NULL ) {
                cur->next = new;                /*     new𖖒[ɘA     */
            }
        } else {                                /*   cur[łȂ       */
            addNode(cur, cur->next, s);         /*     1             */
        }
    } else {                                    /* cur̒O֑}         */
        if ( (new = allocNode(s)) != NULL ) {
            new->next = cur;                    /*   new̎cur          */
            if ( prev == NULL ) {               /*   cur͐擪             */
                return new;                     /*     VȐ擪new     */
            } else {                            /*   cur͐擪ł͂Ȃ     */
                prev->next = new;               /*     Õm[h̎new */
            }
        }
    }

    return cur;         /* ܂ŗꍇ́CXg̐擪ɕωȂ */
}

/*
 * Vm[ĥ߂̗̈mۂD
 * s  L镶
 * ߂l: mۂꂽ̈w|C^
 */
Node *
allocNode(char *s)
{
    Node        *new;

    /* Node^̊m */
    if ( (new = (Node *)malloc(sizeof(Node))) == NULL ) {
        printf("̊mۂɎs\n");
        return NULL;
    }
    /* ̗̈m (+1) */
    if ( (new->word = (char *)malloc(strlen(s)+1)) == NULL ) {
        printf("̊mۂɎs\n");
        free(new);
        return NULL;
    }
    new->next  = NULL;
    new->count = 1;
    strcpy(new->word, s);

    return new;
}
    
/*
 * pwm[h擪Ƃ郊Xg̃f[^\
 */
void
printAllNode(Node *p)
{
    while ( p != NULL ) {
        printf("%5d: %s\n", p->count, p->word);
        p = p->next;
    }
}
